diff mbox series

[v2] ext4/046: Add a test for inline_data vs. DAX inode flag

Message ID 20201027022021.573736-1-yangx.jy@cn.fujitsu.com (mailing list archive)
State New, archived
Headers show
Series [v2] ext4/046: Add a test for inline_data vs. DAX inode flag | expand

Commit Message

Xiao Yang Oct. 27, 2020, 2:20 a.m. UTC
Inline_data is mutually exclusive to DAX inode flag so enabling both
of them is not expected and triggers some errors.  It's a regression
test for kernel patch:
commit aa2f77920b74 ("ext4: disallow modifying DAX inode flag if inline_data has been set")

Signed-off-by: Xiao Yang <yangx.jy@cn.fujitsu.com>
---

V1->V2:
1) Add commit id for kernel patch.
2) Rebase on the lastest xfstests-dev.

 tests/ext4/047     | 56 ++++++++++++++++++++++++++++++++++++++++++++++
 tests/ext4/047.out |  2 ++
 tests/ext4/group   |  1 +
 3 files changed, 59 insertions(+)
 create mode 100755 tests/ext4/047
 create mode 100644 tests/ext4/047.out

Comments

Xiao Yang Oct. 27, 2020, 3:05 a.m. UTC | #1
Hi,

Please ignore this mail because of the wrong test number on subject. :-(
I will resend the v2 patch.

Best Regards,
Xiao Yang
On 2020/10/27 10:20, Xiao Yang wrote:
> Inline_data is mutually exclusive to DAX inode flag so enabling both
> of them is not expected and triggers some errors.  It's a regression
> test for kernel patch:
> commit aa2f77920b74 ("ext4: disallow modifying DAX inode flag if inline_data has been set")
>
> Signed-off-by: Xiao Yang <yangx.jy@cn.fujitsu.com>
> ---
>
> V1->V2:
> 1) Add commit id for kernel patch.
> 2) Rebase on the lastest xfstests-dev.
>
>  tests/ext4/047     | 56 ++++++++++++++++++++++++++++++++++++++++++++++
>  tests/ext4/047.out |  2 ++
>  tests/ext4/group   |  1 +
>  3 files changed, 59 insertions(+)
>  create mode 100755 tests/ext4/047
>  create mode 100644 tests/ext4/047.out
>
> diff --git a/tests/ext4/047 b/tests/ext4/047
> new file mode 100755
> index 00000000..116158f5
> --- /dev/null
> +++ b/tests/ext4/047
> @@ -0,0 +1,56 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +# Copyright (c) 2020 Fujitsu.  All Rights Reserved.
> +#
> +# FS QA Test 047
> +#
> +# This is a regression test for kernel patch:
> +# commit aa2f77920b74 ("ext4: disallow modifying DAX inode flag if inline_data has been set")
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1	# failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +	cd /
> +	rm -f $tmp.*
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +# remove previous $seqres.full before test
> +rm -f $seqres.full
> +
> +# real QA test starts here
> +_supported_fs ext4
> +_require_scratch_dax_mountopt "dax=always"
> +_require_dax_iflag
> +_require_scratch_ext4_feature "inline_data"
> +
> +TESTFILE=$SCRATCH_MNT/testfile
> +
> +_scratch_mkfs_ext4 -O inline_data > $seqres.full 2>&1
> +
> +_scratch_mount "-o dax=inode" >> $seqres.full 2>&1
> +
> +echo "Need to make some inline data..." > $TESTFILE
> +
> +# It's fine to disallow modifying DAX inode flag on the file which
> +# has inline_data flag.
> +if $XFS_IO_PROG -c "chattr +x" $TESTFILE >> $seqres.full 2>&1; then
> +	_scratch_cycle_mount "dax=inode"
> +	echo 'Append data' >> $TESTFILE
> +fi
> +
> +# success, all done
> +echo "Silence is golden"
> +status=0
> +exit
> diff --git a/tests/ext4/047.out b/tests/ext4/047.out
> new file mode 100644
> index 00000000..48db9bfe
> --- /dev/null
> +++ b/tests/ext4/047.out
> @@ -0,0 +1,2 @@
> +QA output created by 047
> +Silence is golden
> diff --git a/tests/ext4/group b/tests/ext4/group
> index 70c0bca6..ceda2ba6 100644
> --- a/tests/ext4/group
> +++ b/tests/ext4/group
> @@ -49,6 +49,7 @@
>  044 auto quick
>  045 auto dir
>  046 auto prealloc quick
> +047 auto quick dax
>  271 auto rw quick
>  301 aio auto ioctl rw stress defrag
>  302 aio auto ioctl rw stress defrag
diff mbox series

Patch

diff --git a/tests/ext4/047 b/tests/ext4/047
new file mode 100755
index 00000000..116158f5
--- /dev/null
+++ b/tests/ext4/047
@@ -0,0 +1,56 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Fujitsu.  All Rights Reserved.
+#
+# FS QA Test 047
+#
+# This is a regression test for kernel patch:
+# commit aa2f77920b74 ("ext4: disallow modifying DAX inode flag if inline_data has been set")
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs ext4
+_require_scratch_dax_mountopt "dax=always"
+_require_dax_iflag
+_require_scratch_ext4_feature "inline_data"
+
+TESTFILE=$SCRATCH_MNT/testfile
+
+_scratch_mkfs_ext4 -O inline_data > $seqres.full 2>&1
+
+_scratch_mount "-o dax=inode" >> $seqres.full 2>&1
+
+echo "Need to make some inline data..." > $TESTFILE
+
+# It's fine to disallow modifying DAX inode flag on the file which
+# has inline_data flag.
+if $XFS_IO_PROG -c "chattr +x" $TESTFILE >> $seqres.full 2>&1; then
+	_scratch_cycle_mount "dax=inode"
+	echo 'Append data' >> $TESTFILE
+fi
+
+# success, all done
+echo "Silence is golden"
+status=0
+exit
diff --git a/tests/ext4/047.out b/tests/ext4/047.out
new file mode 100644
index 00000000..48db9bfe
--- /dev/null
+++ b/tests/ext4/047.out
@@ -0,0 +1,2 @@ 
+QA output created by 047
+Silence is golden
diff --git a/tests/ext4/group b/tests/ext4/group
index 70c0bca6..ceda2ba6 100644
--- a/tests/ext4/group
+++ b/tests/ext4/group
@@ -49,6 +49,7 @@ 
 044 auto quick
 045 auto dir
 046 auto prealloc quick
+047 auto quick dax
 271 auto rw quick
 301 aio auto ioctl rw stress defrag
 302 aio auto ioctl rw stress defrag